"use strict";
/* eslint-disable @typescript-eslint/no-explicit-any */
Object.defineProperty(exports, "__esModule", { value: true });
exports.initReducer = exports.commonReducer = exports.commonActions = void 0;
/**
 * Actions Mixin provides reset and update actions
 */
exports.commonActions = {
    reset: undefined,
    update: (payload) => payload,
};
/**
 * Common reducer.
 * Supports UPDATE and RESET actions
 */
const commonReducer = (actions, DEFAULT) => ({
    [actions.reset.type]: () => DEFAULT,
    [actions.update.type]: (state, { payload }) => ({ ...state, ...payload }),
});
exports.commonReducer = commonReducer;
/**
 * Initial reducer.
 * Supports INIT action
 */
const initReducer = (actions) => ({
    [actions.init.type]: (state) => ({ ...state, inited: true }),
});
exports.initReducer = initReducer;
