import { Actions } from './types'
/**
 * Actions Mixin provides reset and update actions
 */
export declare const commonActions: {
  reset: any
  update: <T>(payload: T) => T
}
/**
 * Common reducer.
 * Supports UPDATE and RESET actions
 */
export declare const commonReducer: <
  T extends Record<string, any> & {
    reset: any
    update: <T>(payload: T) => T
  },
  S,
>(
  actions: Actions<string, T>,
  DEFAULT: S,
) => {
  [x: string]: (
    state: object,
    {
      payload,
    }: {
      payload: any
    },
  ) => any
}
/**
 * Initial reducer.
 * Supports INIT action
 */
export declare const initReducer: (actions: Actions<string, Record<string, any>>) => {
  [x: string]: (state: any) => any
}
