/* eslint-disable @typescript-eslint/no-explicit-any */
/**
 * Actions Mixin provides reset and update actions
 */
export const commonActions = {
  reset: undefined,
  update: (payload) => payload,
}
/**
 * Common reducer.
 * Supports UPDATE and RESET actions
 */
export const commonReducer = (actions, DEFAULT) => ({
  [actions.reset.type]: () => DEFAULT,
  [actions.update.type]: (state, { payload }) => Object.assign(Object.assign({}, state), payload),
})
/**
 * Initial reducer.
 * Supports INIT action
 */
export const initReducer = (actions) => ({
  [actions.init.type]: (state) => Object.assign(Object.assign({}, state), { inited: true }),
})
