import { Action } from 'redux'
import { ThunkAction } from 'redux-thunk'
declare type StringKeys<Object> = Extract<keyof Object, string>
declare type Identity<T> = (arg: T) => T
export declare type ActionCreatorResult<TypeName extends string, Result> = Result extends Action
  ? Result
  : Result extends (dispatch: any, getState: () => any, extraArgument: infer Arg) => infer R
  ? ThunkAction<R, any, Arg, any>
  : Result extends Promise<infer R>
  ? ThunkAction<R, any, never, never>
  : {
      type: TypeName
      payload: Result
    }
export interface ActionCreator<TypeName extends string, Result> {
  type: TypeName
  toString(): TypeName
  (...args: any): ActionCreatorResult<TypeName, Result>
}
export declare type MixType<T> = T extends string[]
  ? {
      [K in T[number]]: Identity<unknown>
    }
  : {
      [K in Extract<keyof T, string>]: T[K]
    }
export declare type Actions<Prefix extends string, Source> = {
  readonly [K in StringKeys<Source>]: ActionCreator<
    `${Prefix}${K}`,
    Source[K] extends (...args: any[]) => infer R ? R : Source[K]
  >
}
export {}
